require 'libs/TLfres'
require 'libs/json'
anim8 = require 'libs/anim8'

require 'enemy'
require 'resolution'

function love.load()
	owl       = love.graphics.newImage("textures/owl2.png")
	owlNorm   = love.graphics.newImage("textures/owl2.png")
	owlRed    = love.graphics.newImage("textures/owl2Red.png")
	owl_stand = love.graphics.newImage("textures/owl.png")
	owl_standNorm = love.graphics.newImage("textures/owl.png")
	owl_standRed = love.graphics.newImage("textures/owlRed.png")
	
	street    = love.graphics.newImage("textures/background.png")
	bikeMan   = love.graphics.newImage("textures/bike.png")
	laser     = love.graphics.newImage("textures/laser.png")
	
	local anim_grid = anim8.newGrid(128, 128, owl:getWidth(), owl:getHeight())
	anim_Owl = anim8.newAnimation('loop', anim_grid('1-2,1'), 0.1)
	anim_Owl_Stand = anim8.newAnimation('loop', anim_grid('1-2,1'), 0.5)
	
	local anim_grid = anim8.newGrid(96, 102, bikeMan:getWidth(), bikeMan:getHeight())
	anim_Bike = anim8.newAnimation('loop', anim_grid('1-2,1'), 0.1)
	
	player = {
		x = 4,
		y = 128,
		speed = 200,
		bullets = {},
		health = 100,
		laser = 20,
	}
	
	enemy = {}
	remEnemy = {}
	enemyTimer = 0
	
	loadResolution()
end

function love.update(dt)
	if love.keyboard.isDown("up") and (not love.keyboard.isDown("x") or player.laser <= 0) then
		if player.y >= 42 then
			player.y = player.y - (player.speed * dt)
		end
	elseif love.keyboard.isDown("down") and (not love.keyboard.isDown("x") or player.laser <= 0) then
		if player.y + owl:getHeight() <= 678 then
			player.y = player.y + (player.speed * dt)
		end
	end
	
	anim_Owl:update(dt)   
	anim_Owl_Stand:update(dt)
	anim_Bike:update(dt)
	
	if love.keyboard.isDown("x") and (love.keyboard.isDown("up") or love.keyboard.isDown("down")) then
		owl = owlRed
	else
		if owl == owlRed then
			owl = owlNorm
		end
	end
	
	if love.keyboard.isDown("x") and not (love.keyboard.isDown("up") or love.keyboard.isDown("down")) then
		owl_stand = owl_standRed
	else
		if owl_stand == owl_standRed then
			owl_stand = owl_standNorm
		end
	end
	
	if love.keyboard.isDown("x") then
		if player.laser > 0 then
			shoot()
			player.laser = player.laser - 0.05
		end
	elseif player.laser <= 20 then
		player.laser = player.laser + 0.005
	end
	
	updateEnemy(enemy, dt)
	
	if enemyTimer >= 3 then
		makeEnemy(1, enemy)
		enemyTimer = 0
	else
		enemyTimer = enemyTimer + (1 * dt)
	end
	
	local remShot = {} --The Bullet Processes
	for i,v in ipairs(player.bullets) do
		v.x = v.x + dt * 600 --Moves the bullets
			
		if v.x > 1290 then
			table.insert(remShot, i) --Inserts bullets for deletion
		end
	end
	
	for i,v in ipairs(remShot) do
		table.remove(player.bullets, v) --Delets bullets
	end
end

function love.draw()
	TLfres.transform()
	
	love.graphics.draw(street, 0, 0)
	
	if love.keyboard.isDown("up") or love.keyboard.isDown("down") then
		anim_Owl:draw(owl, player.x, player.y)
	else
		anim_Owl_Stand:draw(owl_stand, player.x, player.y)
	end
	
	for i,v in ipairs(player.bullets) do --Draws the bullets
		love.graphics.draw(laser, v.x, v.y)
	end
	
	for i,v in ipairs(enemy) do --Draws the Enemies
		if v.id == 1 then
			anim_Bike:draw(bikeMan, v.x, v.y)
		end
	end
	
	love.graphics.print("Laser:"..player.laser, 0, 0)
	love.graphics.print("FPS:"..love.timer.getFPS(), 600, 0)
end

function love.keypressed(key)
	if key == '1' then
		resolution = 1
		updateResolution(resolution, ctrl)
	elseif key == '2' then
		resolution = 2
		updateResolution(resolution, ctrl)
	elseif key == '3' then
		resolution = 3
		updateResolution(resolution, ctrl)
	end
end

function shoot()
	local shot = {} --Makes a bullet
	shot.x = player.x + 88
	shot.y = player.y + 56
	
	table.insert(player.bullets, shot)
end